-- Scripted orbit Lua function to control the visibility of ThisObj and ThatObj.
-- created by s.ball, 21 feb 2019
-- no rights reserved: do with it whatever you want

-- if the distance between the observer's viewpoint and "this"
-- is greater than minDist, then show "this"
-- else show "that"

change_visibility = function (minDist, this, that)

      local camera  = celestia:getobserver()
      local thisObj = celestia:find(this)
      local thatObj = celestia:find(that)

      local cameraPos = camera:getposition()
      local thisPos = thisObj:getposition()

      local dist = thisPos:distanceto(cameraPos)
      
      if (dist > minDist) 
      then
        thisObj:setvisible(true)
	thatObj:setvisible(false)
      else
        thisObj:setvisible(false)
	thatObj:setvisible(true)
      end
end

Visibility = function (sscvals)

	local orbit = {}
	orbit.params = sscvals;
	orbit.boundingRadius = 1e5

-- the function orbit:position is called by Celestia once every time Celestia refreshes its window
-- to determine the object's current position

	function orbit:position (tjd)
	
		 change_visibility(
		        self.params.VisibleDistance,
			self.params.ThisObject,
			self.params.ThatObject )
			
-- despite whatever is done by the function change_visibility
-- the current object is always positioned at x=0, y=0, z=0
-- relative to its parent object

		 return 0, 0, 0
	end

return orbit
end
